--- old/usr/src/uts/common/os/kstat_fr.c	2013-01-31 12:29:30.720248264 +0000
+++ new/usr/src/uts/common/os/kstat_fr.c	2013-01-31 12:29:30.736768306 +0000
@@ -1207,6 +1207,44 @@
 		ksp->ks_flags &= ~KSTAT_FLAG_DORMANT;
 	}
 
+#ifdef DEBUG
+	/*
+	 * Search for uninitialized kstats.
+	 */
+	switch (ksp->ks_type) {
+	case KSTAT_TYPE_NAMED: {
+		uint_t i;
+		kstat_named_t *knp = KSTAT_NAMED_PTR(ksp);
+
+		for (i = 0; i < ksp->ks_ndata; i++, knp++) {
+			if (knp->data_type > KSTAT_DATA_STRING) {
+				cmn_err(CE_WARN,
+				    "kstat_install('%s', %d, '%s'): "
+				    "invalid data type",
+				    ksp->ks_module, ksp->ks_instance,
+				    ksp->ks_name);
+			}
+
+			/*
+			 * If the name of this kstat is empty
+			 * we assume it is uninitialized.
+			 */
+			if (knp->name[0] == '\0') {
+				cmn_err(CE_WARN,
+				    "kstat_install('%s', %d, '%s'): "
+				    "uninitialized kstat",
+				    ksp->ks_module, ksp->ks_instance,
+				    ksp->ks_name);
+			}
+		}
+
+		break;
+	}
+	default:
+		break;
+	}
+#endif
+
 	/*
 	 * Now that the kstat is active, make it visible to the kstat driver.
 	 */
